package org.tbasket


import org.apache.logging.log4j.LogManager
import zio._

import java.lang
import java.nio.file.{Files, Path}
import java.util.Properties
import scala.io.StdIn
import scala.util.control.NonFatal

object Main {
    final val LOG = LogManager.getLogger("Core")

    def main(args: Array[String]): Unit = {
        LOG.info("Starting server")
        val config = retrieveConfig
        db(config)
        api(config)
        LOG.info("Server successfully started")
    }

    private def db(config: Properties): Unit = new Thread({ () =>
    }, "Database").start()
    //TODO

    private def api(config: Properties): Unit = new Thread({ () =>
        val endpoint = EndpointSetup.setupEndpoint(config)
        val runtime  = Runtime.default
        Unsafe.unsafe { implicit u =>
            runtime.unsafe.run(endpoint.run).catchSome {
                case NonFatal(e) =>
                    e.printStackTrace()
                    throw e
            }
        }
    }: Runnable, "API").start()

    private def retrieveConfig: Properties = {
        val configFile = Path.of("server.properties")
        if (Files.notExists(configFile)) {
            val in = getClass.getResourceAsStream("/server.properties")
            Files.writeString(configFile, new String(in.readAllBytes()))
        }
        val in         = Files.newInputStream(configFile)
        val properties = new Properties()
        properties.load(in)
        properties
    }

    //add a shutdown hook to log when the server is about to get killed
    lang.Runtime.getRuntime.addShutdownHook(new Thread(() => LOG.info("Server shutdowns")))

}
