package org.tbasket.handler

import org.tbasket.Main
import org.tbasket.api.compute.APIRequestHandler
import zio.http.{Request, Response}

import java.util.concurrent.atomic.AtomicInteger

object IncrementHandler extends APIRequestHandler {

    private val counter = new AtomicInteger(0)

    def getCounter: Int = counter.get()

    override def get(request: Request): Response = {
        Response.json(s"{\"value\": ${counter.get()}}")
    }

    override def post(request: Request): Response = {
        val i = counter.incrementAndGet()
        Main.LOG.trace(s"Counter incremented : $i")
        Response.ok
    }
}
